]> git.ipfire.org Git - thirdparty/git.git/blob - git-merge.sh
Allow whole-tree operations to be started from a subdirectory
[thirdparty/git.git] / git-merge.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 USAGE='[-n] [--no-commit] [--squash] [-s <strategy>] [-m=<merge-message>] <commit>+'
7
8 SUBDIRECTORY_OK=Yes
9 . git-sh-setup
10 set_reflog_action "merge $*"
11 require_work_tree
12 cd_to_toplevel
13
14 test -z "$(git ls-files -u)" ||
15 die "You are in the middle of a conflicted merge."
16
17 LF='
18 '
19
20 all_strategies='recur recursive octopus resolve stupid ours'
21 default_twohead_strategies='recursive'
22 default_octopus_strategies='octopus'
23 no_trivial_merge_strategies='ours'
24 use_strategies=
25
26 index_merge=t
27
28 dropsave() {
29 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
30 "$GIT_DIR/MERGE_SAVE" || exit 1
31 }
32
33 savestate() {
34 # Stash away any local modifications.
35 git-diff-index -z --name-only $head |
36 cpio -0 -o >"$GIT_DIR/MERGE_SAVE"
37 }
38
39 restorestate() {
40 if test -f "$GIT_DIR/MERGE_SAVE"
41 then
42 git reset --hard $head >/dev/null
43 cpio -iuv <"$GIT_DIR/MERGE_SAVE"
44 git-update-index --refresh >/dev/null
45 fi
46 }
47
48 finish_up_to_date () {
49 case "$squash" in
50 t)
51 echo "$1 (nothing to squash)" ;;
52 '')
53 echo "$1" ;;
54 esac
55 dropsave
56 }
57
58 squash_message () {
59 echo Squashed commit of the following:
60 echo
61 git-log --no-merges ^"$head" $remote
62 }
63
64 finish () {
65 if test '' = "$2"
66 then
67 rlogm="$GIT_REFLOG_ACTION"
68 else
69 echo "$2"
70 rlogm="$GIT_REFLOG_ACTION: $2"
71 fi
72 case "$squash" in
73 t)
74 echo "Squash commit -- not updating HEAD"
75 squash_message >"$GIT_DIR/SQUASH_MSG"
76 ;;
77 '')
78 case "$merge_msg" in
79 '')
80 echo "No merge message -- not updating HEAD"
81 ;;
82 *)
83 git-update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
84 ;;
85 esac
86 ;;
87 esac
88 case "$1" in
89 '')
90 ;;
91 ?*)
92 case "$no_summary" in
93 '')
94 git-diff-tree --stat --summary -M "$head" "$1"
95 ;;
96 esac
97 ;;
98 esac
99 }
100
101 merge_name () {
102 remote="$1"
103 rh=$(git-rev-parse --verify "$remote^0" 2>/dev/null) || return
104 bh=$(git-show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
105 if test "$rh" = "$bh"
106 then
107 echo "$rh branch '$remote' of ."
108 elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
109 git-show-ref -q --verify "refs/heads/$truname" 2>/dev/null
110 then
111 echo "$rh branch '$truname' (early part) of ."
112 else
113 echo "$rh commit '$remote'"
114 fi
115 }
116
117 case "$#" in 0) usage ;; esac
118
119 have_message=
120 while case "$#" in 0) break ;; esac
121 do
122 case "$1" in
123 -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
124 --no-summa|--no-summar|--no-summary)
125 no_summary=t ;;
126 --sq|--squ|--squa|--squas|--squash)
127 squash=t no_commit=t ;;
128 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
129 no_commit=t ;;
130 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
131 --strateg=*|--strategy=*|\
132 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
133 case "$#,$1" in
134 *,*=*)
135 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
136 1,*)
137 usage ;;
138 *)
139 strategy="$2"
140 shift ;;
141 esac
142 case " $all_strategies " in
143 *" $strategy "*)
144 use_strategies="$use_strategies$strategy " ;;
145 *)
146 die "available strategies are: $all_strategies" ;;
147 esac
148 ;;
149 -m=*|--m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
150 merge_msg=`expr "z$1" : 'z-[^=]*=\(.*\)'`
151 have_message=t
152 ;;
153 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
154 shift
155 case "$#" in
156 1) usage ;;
157 esac
158 merge_msg="$1"
159 have_message=t
160 ;;
161 -*) usage ;;
162 *) break ;;
163 esac
164 shift
165 done
166
167 # This could be traditional "merge <msg> HEAD <commit>..." and the
168 # way we can tell it is to see if the second token is HEAD, but some
169 # people might have misused the interface and used a committish that
170 # is the same as HEAD there instead. Traditional format never would
171 # have "-m" so it is an additional safety measure to check for it.
172
173 if test -z "$have_message" &&
174 second_token=$(git-rev-parse --verify "$2^0" 2>/dev/null) &&
175 head_commit=$(git-rev-parse --verify "HEAD" 2>/dev/null) &&
176 test "$second_token" = "$head_commit"
177 then
178 merge_msg="$1"
179 shift
180 head_arg="$1"
181 shift
182 elif ! git-rev-parse --verify HEAD >/dev/null 2>&1
183 then
184 # If the merged head is a valid one there is no reason to
185 # forbid "git merge" into a branch yet to be born. We do
186 # the same for "git pull".
187 if test 1 -ne $#
188 then
189 echo >&2 "Can merge only exactly one commit into empty head"
190 exit 1
191 fi
192
193 rh=$(git rev-parse --verify "$1^0") ||
194 die "$1 - not something we can merge"
195
196 git-update-ref -m "initial pull" HEAD "$rh" "" &&
197 git-read-tree --reset -u HEAD
198 exit
199
200 else
201 # We are invoked directly as the first-class UI.
202 head_arg=HEAD
203
204 # All the rest are the commits being merged; prepare
205 # the standard merge summary message to be appended to
206 # the given message. If remote is invalid we will die
207 # later in the common codepath so we discard the error
208 # in this loop.
209 merge_name=$(for remote
210 do
211 merge_name "$remote"
212 done | git-fmt-merge-msg
213 )
214 merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
215 fi
216 head=$(git-rev-parse --verify "$head_arg"^0) || usage
217
218 # All the rest are remote heads
219 test "$#" = 0 && usage ;# we need at least one remote head.
220
221 remoteheads=
222 for remote
223 do
224 remotehead=$(git-rev-parse --verify "$remote"^0 2>/dev/null) ||
225 die "$remote - not something we can merge"
226 remoteheads="${remoteheads}$remotehead "
227 eval GITHEAD_$remotehead='"$remote"'
228 export GITHEAD_$remotehead
229 done
230 set x $remoteheads ; shift
231
232 case "$use_strategies" in
233 '')
234 case "$#" in
235 1)
236 var="`git-repo-config --get pull.twohead`"
237 if test -n "$var"
238 then
239 use_strategies="$var"
240 else
241 use_strategies="$default_twohead_strategies"
242 fi ;;
243 *)
244 var="`git-repo-config --get pull.octopus`"
245 if test -n "$var"
246 then
247 use_strategies="$var"
248 else
249 use_strategies="$default_octopus_strategies"
250 fi ;;
251 esac
252 ;;
253 esac
254
255 for s in $use_strategies
256 do
257 case " $s " in
258 *" $no_trivial_merge_strategies "*)
259 index_merge=f
260 break
261 ;;
262 esac
263 done
264
265 case "$#" in
266 1)
267 common=$(git-merge-base --all $head "$@")
268 ;;
269 *)
270 common=$(git-show-branch --merge-base $head "$@")
271 ;;
272 esac
273 echo "$head" >"$GIT_DIR/ORIG_HEAD"
274
275 case "$index_merge,$#,$common,$no_commit" in
276 f,*)
277 # We've been told not to try anything clever. Skip to real merge.
278 ;;
279 ?,*,'',*)
280 # No common ancestors found. We need a real merge.
281 ;;
282 ?,1,"$1",*)
283 # If head can reach all the merge then we are up to date.
284 # but first the most common case of merging one remote.
285 finish_up_to_date "Already up-to-date."
286 exit 0
287 ;;
288 ?,1,"$head",*)
289 # Again the most common case of merging one remote.
290 echo "Updating $(git-rev-parse --short $head)..$(git-rev-parse --short $1)"
291 git-update-index --refresh 2>/dev/null
292 new_head=$(git-rev-parse --verify "$1^0") &&
293 git-read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
294 finish "$new_head" "Fast forward"
295 dropsave
296 exit 0
297 ;;
298 ?,1,?*"$LF"?*,*)
299 # We are not doing octopus and not fast forward. Need a
300 # real merge.
301 ;;
302 ?,1,*,)
303 # We are not doing octopus, not fast forward, and have only
304 # one common. See if it is really trivial.
305 git var GIT_COMMITTER_IDENT >/dev/null || exit
306
307 echo "Trying really trivial in-index merge..."
308 git-update-index --refresh 2>/dev/null
309 if git-read-tree --trivial -m -u -v $common $head "$1" &&
310 result_tree=$(git-write-tree)
311 then
312 echo "Wonderful."
313 result_commit=$(
314 echo "$merge_msg" |
315 git-commit-tree $result_tree -p HEAD -p "$1"
316 ) || exit
317 finish "$result_commit" "In-index merge"
318 dropsave
319 exit 0
320 fi
321 echo "Nope."
322 ;;
323 *)
324 # An octopus. If we can reach all the remote we are up to date.
325 up_to_date=t
326 for remote
327 do
328 common_one=$(git-merge-base --all $head $remote)
329 if test "$common_one" != "$remote"
330 then
331 up_to_date=f
332 break
333 fi
334 done
335 if test "$up_to_date" = t
336 then
337 finish_up_to_date "Already up-to-date. Yeeah!"
338 exit 0
339 fi
340 ;;
341 esac
342
343 # We are going to make a new commit.
344 git var GIT_COMMITTER_IDENT >/dev/null || exit
345
346 # At this point, we need a real merge. No matter what strategy
347 # we use, it would operate on the index, possibly affecting the
348 # working tree, and when resolved cleanly, have the desired tree
349 # in the index -- this means that the index must be in sync with
350 # the $head commit. The strategies are responsible to ensure this.
351
352 case "$use_strategies" in
353 ?*' '?*)
354 # Stash away the local changes so that we can try more than one.
355 savestate
356 single_strategy=no
357 ;;
358 *)
359 rm -f "$GIT_DIR/MERGE_SAVE"
360 single_strategy=yes
361 ;;
362 esac
363
364 result_tree= best_cnt=-1 best_strategy= wt_strategy=
365 merge_was_ok=
366 for strategy in $use_strategies
367 do
368 test "$wt_strategy" = '' || {
369 echo "Rewinding the tree to pristine..."
370 restorestate
371 }
372 case "$single_strategy" in
373 no)
374 echo "Trying merge strategy $strategy..."
375 ;;
376 esac
377
378 # Remember which strategy left the state in the working tree
379 wt_strategy=$strategy
380
381 git-merge-$strategy $common -- "$head_arg" "$@"
382 exit=$?
383 if test "$no_commit" = t && test "$exit" = 0
384 then
385 merge_was_ok=t
386 exit=1 ;# pretend it left conflicts.
387 fi
388
389 test "$exit" = 0 || {
390
391 # The backend exits with 1 when conflicts are left to be resolved,
392 # with 2 when it does not handle the given merge at all.
393
394 if test "$exit" -eq 1
395 then
396 cnt=`{
397 git-diff-files --name-only
398 git-ls-files --unmerged
399 } | wc -l`
400 if test $best_cnt -le 0 -o $cnt -le $best_cnt
401 then
402 best_strategy=$strategy
403 best_cnt=$cnt
404 fi
405 fi
406 continue
407 }
408
409 # Automerge succeeded.
410 result_tree=$(git-write-tree) && break
411 done
412
413 # If we have a resulting tree, that means the strategy module
414 # auto resolved the merge cleanly.
415 if test '' != "$result_tree"
416 then
417 parents=$(git-show-branch --independent "$head" "$@" | sed -e 's/^/-p /')
418 result_commit=$(echo "$merge_msg" | git-commit-tree $result_tree $parents) || exit
419 finish "$result_commit" "Merge made by $wt_strategy."
420 dropsave
421 exit 0
422 fi
423
424 # Pick the result from the best strategy and have the user fix it up.
425 case "$best_strategy" in
426 '')
427 restorestate
428 case "$use_strategies" in
429 ?*' '?*)
430 echo >&2 "No merge strategy handled the merge."
431 ;;
432 *)
433 echo >&2 "Merge with strategy $use_strategies failed."
434 ;;
435 esac
436 exit 2
437 ;;
438 "$wt_strategy")
439 # We already have its result in the working tree.
440 ;;
441 *)
442 echo "Rewinding the tree to pristine..."
443 restorestate
444 echo "Using the $best_strategy to prepare resolving by hand."
445 git-merge-$best_strategy $common -- "$head_arg" "$@"
446 ;;
447 esac
448
449 if test "$squash" = t
450 then
451 finish
452 else
453 for remote
454 do
455 echo $remote
456 done >"$GIT_DIR/MERGE_HEAD"
457 echo "$merge_msg" >"$GIT_DIR/MERGE_MSG"
458 fi
459
460 if test "$merge_was_ok" = t
461 then
462 echo >&2 \
463 "Automatic merge went well; stopped before committing as requested"
464 exit 0
465 else
466 {
467 echo '
468 Conflicts:
469 '
470 git ls-files --unmerged |
471 sed -e 's/^[^ ]* / /' |
472 uniq
473 } >>"$GIT_DIR/MERGE_MSG"
474 if test -d "$GIT_DIR/rr-cache"
475 then
476 git-rerere
477 fi
478 die "Automatic merge failed; fix conflicts and then commit the result."
479 fi